SystemOrganization addCategory: #'GT-InspectorExtensions-CoreRoassal'!

!String methodsFor: '*GT-InspectorExtensions-CoreRoassal' stamp: 'AndreiChis 8/28/2014 19:53'!
asComment
	self flag: 'Need to be compatible with Pharo 4. Remove me once Moose moves to Pharo 4'.
	^ self asSmalltalkComment! !

!CPSequential methodsFor: '*GT-InspectorExtensions-CoreRoassal' stamp: 'TudorGirba 4/25/2014 15:16'!
gtInspectorPreviewIn: composite
	<gtInspectorPresentationOrder: 40>
	composite roassal2
		title: 'View';
		painting: [ :view | self viewOn: view ]! !

!RTNameCloud class methodsFor: '*GT-InspectorExtensions-CoreRoassal' stamp: 'AndreiChis 10/29/2014 23:43'!
examplesProvider

	^ RTNameCloudExample new! !

!RTMapBuilder class methodsFor: '*GT-InspectorExtensions-CoreRoassal' stamp: 'AndreiChis 10/29/2014 23:27'!
examplesProvider

	^ RTMapExample new! !

!RTExampleSelection methodsFor: '*GT-InspectorExtensions-CoreRoassal' stamp: 'AndreiChis 10/30/2014 23:01'!
gtDisplaySourceIn: composite
	<gtInspectorPresentationOrder: -8>
	^ composite smalltalkCode
		beForScripting;
		title: 'Source';
		format: [ 
			| source firstLine sourceWithoutFirstLine |
			source := (exampleObject class >> selector) getSource.
			firstLine := source lines first.
			sourceWithoutFirstLine := source copyFrom: firstLine size + 1 to: source size.
			sourceWithoutFirstLine ];
		act: [ :text :page |
				text selectionInterval: (1 to: text text size).
				text evaluateSelectionAndDo: [ :result | text selection: result ] ]
			icon: GLMUIThemeExtraIcons glamorousGo
			on: $g
			entitled: 'Do it all and go (g)'
		! !

!RTExampleSelection methodsFor: '*GT-InspectorExtensions-CoreRoassal' stamp: 'AlexandreBergel 10/29/2014 14:17'!
gtInspectorViewIn: composite
	<gtInspectorPresentationOrder: -10>
	composite roassal2
		title: 'Canvas';
		initializeView: [ exampleObject perform: selector ]
		! !

!RTExampleSelection methodsFor: '*GT-InspectorExtensions-CoreRoassal' stamp: 'AndreiChis 10/30/2014 14:26'!
isGTExample

	^ true! !

!GLMSystemWindow methodsFor: '*GT-InspectorExtensions-CoreRoassal' stamp: 'TudorGirba 12/18/2013 05:26'!
gtInspectorOpenTreeIn: composite
	<gtInspectorPresentationOrder: 30>  
	^ (self model 
		gtInspectorOpenTreeIn: composite)
		title: 'Browser tree'! !

!RTBuilder methodsFor: '*GT-InspectorExtensions-CoreRoassal' stamp: 'TudorGirba 10/5/2014 12:16'!
gtInspectorViewIn: composite
	<gtInspectorPresentationOrder: -10>
	composite roassal2
		title: 'View';
		initializeView: [ self ]! !

!CPQualitative methodsFor: '*GT-InspectorExtensions-CoreRoassal' stamp: 'TudorGirba 4/25/2014 15:16'!
gtInspectorPreviewIn: composite
	<gtInspectorPresentationOrder: 40>
	composite roassal2
		title: 'View';
		painting: [ :view | self viewOn: view ]! !

!RTMondrianViewBuilder class methodsFor: '*GT-InspectorExtensions-CoreRoassal' stamp: 'TudorGirba 11/30/2014 18:01'!
gtInspectorMondrianExamplesIn: composite
	<gtInspectorPresentationOrder: 0>
	^ RTMondrianExample new gtInspectorPreviewIn: composite! !

!RTAbstractExample class methodsFor: '*GT-InspectorExtensions-CoreRoassal' stamp: 'AlexandreBergel 10/29/2014 13:54'!
gtInspectorPreviewIn: composite
	<gtInspectorPresentationOrder: 4>
	^ self new gtInspectorPreviewIn: composite! !

!RTAbstractExample methodsFor: '*GT-InspectorExtensions-CoreRoassal' stamp: 'AndreiChis 10/30/2014 14:40'!
gtDisplayExamplesIn: aComposite

	^ (self gtInspectorPreviewIn: aComposite)
		title: 'E.g'! !

!RTAbstractExample methodsFor: '*GT-InspectorExtensions-CoreRoassal' stamp: 'AndreiChis 10/30/2014 14:40'!
gtInspectorPreviewIn: composite
	<gtInspectorPresentationOrder: 4>
	^ composite roassal2
		title: 'Examples';
		when: [ self gtExamples notEmpty ];
		send: [ :example | example result ];
		painting: [ :view | 
			view @ RTDraggableView.
			self gtOpenOn: view ]! !

!MethodContext methodsFor: '*GT-InspectorExtensions-CoreRoassal' stamp: 'TudorGirba 11/13/2013 06:44'!
gtInspectorSourceIn: composite
	<gtInspectorPresentationOrder: 30> 
	self method gtInspectorSourceIn: composite! !

!MessageTally methodsFor: '*GT-InspectorExtensions-CoreRoassal' stamp: 'TudorGirba 10/27/2014 00:26'!
gtInspectorMessageTreeIn: composite
	<gtInspectorPresentationOrder: 40>
	| methods normalizer |
	methods := self withDeepCollect: #children.
	normalizer := RTNColorLinearNormalizer 
						inContext: methods 
						withCommand: #tally 
						lowColor: Color gray 
						highColor: Color red.
	^ (composite tree)
		title: 'Tree';
		children: [ :each | each children ];
		"rootsExpanded;"
		format: [ :each | 
			Text 
				string: each gtDisplayString
				attributes: { TextColor color: (normalizer rtValue: each)}];
		when: [ self children notEmpty ];
		filterOn: [ :text :each | each gtDisplayString includesSubstring: text caseSensitive: false ];
		morphicSelectionAct: [ :list | list selection method browse ]
			icon: GLMUIThemeExtraIcons glamorousBrowse
			on: $b
			entitled: 'Browse (b)'
		! !

!MessageTally methodsFor: '*GT-InspectorExtensions-CoreRoassal' stamp: 'TudorGirba 10/4/2014 07:19'!
gtInspectorPerformanceChartIn: composite
	<gtInspectorPresentationOrder: 40>
	| metric |
	metric := #localTally.
	^ composite roassal2
		title: 'Top tallies';
		initializeView: [ RTDoubleBarBuilder new ];
		painting: [ :builder :presentation |
			GTInspectorMessageTallyCharter new 
				performanceOf: self 
				with: builder
				in: presentation ];
		when: [ self children notEmpty ]! !

!RTView methodsFor: '*GT-InspectorExtensions-CoreRoassal' stamp: 'TudorGirba 11/1/2014 23:12'!
gtInspectorElementsHierarchyIn: composite
	<gtInspectorPresentationOrder: 20>
	composite table 
		title: 'Elements';
		showOnly: 50;
		display: [ :each | each elements ];
		children: #nestedElements;
		column: 'Model' evaluated: [ :each | each model asString ];
		column: 'Shape' evaluated: [ :each | each shape asString ]! !

!RTView methodsFor: '*GT-InspectorExtensions-CoreRoassal' stamp: 'AlexandreBergel 3/31/2014 14:24'!
gtInspectorViewIn: composite
	<gtInspectorPresentationOrder: -10>
	composite roassal2
		title: 'View';
		initializeView: [ self ]
		! !

!GLMCompositePresentation methodsFor: '*GT-InspectorExtensions-CoreRoassal' stamp: 'TudorGirba 10/24/2014 06:52'!
gtInspectorOpenTreeIn: composite
	<gtInspectorPresentationOrder: 30>  
	^ composite roassal2
		title: 'Tree';
		painting: [:view :b | 
			self viewTreeOn: view ]! !

GLMCompositePresentation subclass: #GTInspectorMessageTallyCharter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-InspectorExtensions-CoreRoassal'!

!GTInspectorMessageTallyCharter commentStamp: 'TudorGirba 1/18/2014 14:28' prior: 0!
Helper class for displaying charts specific for a MessageTally.!

!GTInspectorMessageTallyCharter methodsFor: 'visualization' stamp: 'TudorGirba 10/26/2014 21:01'!
performanceOf: aMessageTally with: builder in: presentation
	"Displays a double chart showing the top 20 most costly methods within a MessageTally.
	For each method it sows the number of occurences of a method and the 
	total amount of local tallies for that method. Useful for identifying outliers 
	within one execution."
	
	| all grouped metric |
	metric := #localTally.
	all := aMessageTally deepCollect: [ :each | each sonsOver: 1 ].
	grouped := (all groupedBy: [ :each | String streamContents: [:s | each gtDisplayIdentifierOn: s] ]) 
						associations sorted: [:a :b | 
									(a value sumNumbers: metric) > 
									(b value sumNumbers: metric) ].
	grouped := (grouped first: (20 min: grouped size)) select: [:each | (each value sumNumbers: metric) > 0].
	builder pointName: [ :each | each key ].
	builder points: grouped.
	builder bottomValue: [ :each | each key size ] titled: 'Locations'.
	builder topValue: [ :each | each value sumNumbers: metric ] titled: 'Tallies'! !

!FileReference methodsFor: '*GT-InspectorExtensions-CoreRoassal' stamp: 'TudorGirba 10/4/2014 07:28'!
gtInspectorGroupedFilesIn: composite
	<gtInspectorPresentationOrder: 40>
	^ composite roassal2
		title: 'Grouped files';
		initializeView: [ RTDoubleBarBuilder new ];
		painting: [ :builder :presentation |
			| metric all grouped |
			metric := #size.
			all := self allFiles.
			grouped := (all groupedBy: [ :each | each extension ]) 
								associations sorted: [:a :b | 
											(a value sumNumbers: metric) > 
											(b value sumNumbers: metric) ].
			grouped := (grouped first: (20 min: grouped size)) select: [:each | 
					(each value sumNumbers: metric) > 0].
			builder pointName: [ :each | each key ].
			builder points: grouped.
			builder bottomValue: [ :each | each value size ] titled: 'Number of files'.
			builder 
				topValue: [ :each | (each value sumNumbers: metric) / 1000000 ] 
				titled: 'Total size in MB'];
		when: [self isDirectory and: [self hasChildren]]! !

!MetacelloVersion methodsFor: '*GT-InspectorExtensions-CoreRoassal' stamp: 'TudorGirba 11/23/2014 22:34'!
gtInspectorProjectMapIn: composite
	<gtInspectorPresentationOrder: 40>
	composite roassal2
		title: 'Project map';
		initializeView: [ RTMondrianViewBuilder new ];
		painting: [ :view |
			view shape label.
			view nodes: self allProjects.
			view 
				edgesFrom: #yourself 
				toAll: [:each | each projects collect: #version].
			view horizontalDominanceTreeLayout ]! !

!TRCanvas methodsFor: '*GT-InspectorExtensions-CoreRoassal' stamp: 'AlexandreBergel 9/8/2014 11:41'!
gtInspectorViewIn: composite
	<gtInspectorPresentationOrder: -10>
	composite roassal2
		title: 'Canvas';
		initializeView: [ RTView new setCanvas: self ]
		! !

!RTGraphBuilder class methodsFor: '*GT-InspectorExtensions-CoreRoassal' stamp: 'AndreiChis 10/29/2014 23:24'!
examplesProvider

	^ RTGraphBuilderExample new ! !

!RTGraphBuilder methodsFor: '*GT-InspectorExtensions-CoreRoassal' stamp: 'TudorGirba 4/21/2014 21:33'!
gtInspectorViewIn: composite
	<gtInspectorPresentationOrder: -10>
	composite roassal2
		title: 'View';
		initializeView: [ self ]! !

!CPDiverging methodsFor: '*GT-InspectorExtensions-CoreRoassal' stamp: 'TudorGirba 4/25/2014 15:16'!
gtInspectorPreviewIn: composite
	<gtInspectorPresentationOrder: 40>
	composite roassal2
		title: 'View';
		painting: [ :view | self viewOn: view ]! !

!GLMBrowser methodsFor: '*GT-InspectorExtensions-CoreRoassal' stamp: 'TudorGirba 10/24/2014 06:52'!
gtInspectorOpenTreeIn: composite
	<gtInspectorPresentationOrder: 30>  
	^ composite roassal2
		title: 'Tree';
		painting: [:view :b | 
			self viewTreeOn: view ]! !

!ContextPart methodsFor: '*GT-InspectorExtensions-CoreRoassal' stamp: 'AndreiChis 6/25/2014 23:13'!
gtInspectorVariableValuePairs
	"We override the variables with context specific ones"
	| tempIndex |
	tempIndex := 0.
	^ super gtInspectorVariableValuePairs
		addAll:
				(self tempNames
						collect: [ :tempName ||value|
							tempIndex := tempIndex + 1.
							value := [self debuggerMap namedTempAt: tempIndex in: self] 
								on: Error 
								do: [value := (Text string: 'error obtaining field value' attribute: TextColor red) asString ].
							('[' , tempName , ']') -> value ]);
		yourself! !
